Smart Proxy - Bug #4686

Proxy attempts to load Puppet config at /usr/share/foreman-proxy/.puppet/puppet.conf
03/18/2014 03:29 PM - Erik Jacobs

Status: Closed

Priority: High

Assignee: Dominic Cleal

Category: Puppet

Target version: 1.4.2

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:

Pull request:

Description

foreman-1.5.0-0.develop.2014031810564it801a90d.el6.noarch
foreman-postgresql-1.5.0-0.develop.201403181056git801a90d.el6.noarch
foreman-proxy-1.5.0-0.develop.201403141615qit2f75941.el6.noarch
foreman-release-1.5.0-0.develop.201403181056¢it801a90d.el6.noarch
katello-1.5.0-14.201403181055git0744549.el6.noarch
katello-apache-1.0-1.noarch

katello-ca-1.0-1.noarch

katello-certs-tools-1.5.2-1.git.1.edab2c4.el6.noarch
katello-installer-0.0.19-1.201403121737it943ff82.el6.noarch
katello-repos-1.5.1-1.git.14.0868bd1.el6.noarch
pulp-katello-plugins-0.2-1.el6.noarch
ruby193-rubygem-foreman-tasks-0.4.0-1.el6.noarch
ruby193-rubygem-katello-1.5.0-10.201403181055git0744549.el6.noarch
rubygem-foreman_api-0.1.11-1.el6.noarch
rubygem-hammer_cli_foreman-0.0.18-1.el6.noarch
rubygem-hammer_cli_foreman_tasks-0.0.1-3.el6.noarch
rubygem-hammer_cli_katello-0.0.3-1.201403171704git261a615.git.0.eb070b4.el6.noarch
rubygem-katello_api-0.0.8-1.201403171700git2b8a301.git.0.da8522e.el6.noarch

When attempting to publish a puppet-based repository that contains only 2 modules, the following error occurs in delayed_job.log:

1. Logfile created on 2014-03-18 10:29:25 -0400 by logger.rb/31641
2014-03-18T10:29:25-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] Starting job worker
2014-03-18T10:53:07-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] Katello::Repository#after_sync
completed after 51.6695
2014-03-18T10:53:07-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] 1 jobs processed at 0.0193 j/s, 0 failed

2014-03-18T10:56:24-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] Katello::Repository#after_sync
completed after 31.9576
2014-03-18T10:56:24-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] 1 jobs processed at 0.0313 j/s, 0 failed

2014-03-18T10:57:26-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] Katello::Repository#after_sync
completed after 1.9349
2014-03-18T10:57:26-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] 1 jobs processed at 0.5132 j/s, 0 failed

2014-03-18T11:09:52-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] Katello::Repository#after_sync
completed after 116.2491
2014-03-18T11:09:52-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] 1 jobs processed at 0.0086 j/s, 0 failed

2014-03-18T11:16:01-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)]
Katello::ContentViewDefinition#generate_repos failed with RestClient::NotAcceptable: 406 Not Acceptable - 0 failed attempts
2014-03-18T11:16:01-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] PERMANENTLY removing
Katello::ContentViewDefinition#generate_repos because of 1 consecutive failures.

406 Not Acceptable

/opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/abstract_response.rb:48:in “return!'
/opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:220:in “process_result'
/opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:169:in “block in transmit’

/opt/rh/ruby193/root/usr/share/ruby/net/http.rb:746:in “start’

/opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:166:in “transmit’
/opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:60:in “execute’
/opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:31:in “execute’
/opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/resource.rb:51:in “get’

/usr/share/foreman/lib/proxy_api/resource.rb:68:in “get'
/usr/share/foreman/lib/proxy_api/puppet.rb:9:in “environments'
/usr/share/foreman/app/services/puppet_class_importer.rb:133:in “actual_environments'
/usr/share/foreman/app/services/puppet_class_importer.rb:24:in “changes'

/opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/services/katello/puppet_class_|i

‘update_environment'

importer_extensions.rb:22:in

/opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/katello/foreman.rb:35:in “update_foreman_content'
/opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/models/katello/content_view_definition.rb:96:in “generate_repos'
/opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/models/katello/async_operation.rb:57:in “perform’
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/backend/base.rb:94:in "block in invoke_job'

/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:60:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:60:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:65:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:65:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:38:in

“call'

“block in initialize'
“call'

“execute'
“run_callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/backend/base.rb:91:in “invoke_job'

/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:178:in °
/opt/rh/ruby193/root/usr/share/ruby/timeout.rb:69:in “timeout’
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:178:in
/opt/rh/ruby193/root/usr/share/ruby/benchmark.rb:295:in “realtime’
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:177:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:234:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:60:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:60:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:65:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:65:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:38:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:234:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:162:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:161:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:161:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:133:in
/opt/rh/ruby193/root/usr/share/ruby/benchmark.rb:295:in “realtime’
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:132:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:60:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:60:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:65:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:65:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:38:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:129:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:128:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:128:in

block (2 levels) in run'

“block in run'

run'

“block in reserve_and_run_one_job'
“call'

“block in initialize'

“call'

“execute'

“run_callbacks'
‘reserve_and_run_one_job'
“block in work_off"

“times'

‘work_off'

“block (4 levels) in start'

“block (3 levels) in start'
“call

“block in initialize’

“call'

“execute'
“run_callbacks'

“block (2 levels) in start'
“loop'

“block in start'

/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/plugins/clear_locks.rb:7:in “call'
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/plugins/clear_locks.rb:7:in “block (2 levels) in

<class:ClearLocks>'

/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:78:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:78:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:60:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:60:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:78:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:78:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:65:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:65:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/lifecycle.rb:38:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/worker.rb:127:in
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/command.rb:101:

“call'

“block (2 levels) in add'
“call'

“block in initialize'

“call'

“block in add'

“call'

“execute’
“run_callbacks'

“start'

in “run'

/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/command.rb:89:in “block in run_process'

/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/application.rb:249:i
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/application.rb:249:i
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/daemonize.rb:197:i
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/daemonize.rb:197:i

05/17/2024

n “call'

n “block in start_proc'
n “call

n “call_as_daemon’

2/4




/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/application.rb:253:in “start_proc'
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/application.rb:293:in “start'
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/controller.rb:70:in “run’
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons.rb:195:in “block in run_proc'
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/cmdline.rb:109:in “call’
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons/cmdline.rb:109:in “catch_exceptions'
/opt/rh/ruby193/root/usr/share/gems/gems/daemons-1.1.4/lib/daemons.rb:194:in “run_proc'
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/command.rb:87:in “run_process'
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/command.rb:80:in “block in daemonize'
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/command.rb:78:in “times'
/opt/rh/ruby193/root/usr/share/gems/gems/delayed_job-3.0.2/lib/delayed/command.rb:78:in "daemonize’
/usr/bin/katello-jobs:9:in “<main>"'

2014-03-18T11:16:01-0400: [Worker(delayed_job host:satellite.ejacobs.local pid:4488)] 1 jobs processed at 0.0756 j/s, 1 failed

| have attached the two puppet modules.
Steps:

. create a product

. create a repository for puppet modules

. upload the two modules

. create a content view for the puppet repository
. publish the view

a b wmn =

The error above occurs.

Related issues:
Related to Smart Proxy - Bug #4658: Environment list returns undefined method... Closed 03/14/2014

Associated revisions

Revision 597ab3ab - 03/21/2014 05:28 PM - Dominic Cleal

fixes #4686 - don't rely on Puppet[:config] to store config file location

History

#1 - 03/19/2014 05:10 AM - Mike McCune

An even simpler way to reproduce this:

1. lay down some puppet modules in /etc/puppet/environments/
2. Attempt to import classes from a Smart Proxy running on the same machine
3. Note error in the smart proxy log:

I, [2014-03-18T20:59:56.575526 #4632] INFO -- : Initializing from Puppet config file: /etc/puppet/puppet.conf
E, [2014-03-18T20:59:56.579946 #4632] ERROR -- : Failed to list puppet environments: Puppet config at
/usr/share/foreman-proxy/.puppet/puppet.conf was not found

there was some discussion on IRC that puppet-2.7 may be the culprit but it is unknown exactly what causes this error.
A system where this is occurring is:

dhcp-8-29-214.1ab.eng.rdu2.redhat.com with our standard internal login/password

#2 - 03/19/2014 08:34 AM - Dominic Cleal

- Project changed from Katello to Smart Proxy

- Subject changed from (nightlies 3-18-14) publishing puppet repositories breaks delayed_job to Proxy attempts to load Puppet config at
/usr/share/foreman-proxy/.puppet/puppet.conf

- Category set to Puppet

#3 - 03/19/2014 08:34 AM - Dominic Cleal
- Related to Bug #4658: Environment list returns undefined method '[]' for nil:NilClass on Puppet 3.5 added

#4 - 03/19/2014 08:35 AM - Dominic Cleal

- Target version set to 1.9.0
https://projects.theforeman.org/issues/4632
https://projects.theforeman.org/issues/4632

#5 - 03/19/2014 09:09 AM - Dominic Cleal

- translation missing: en.field_release set to 7

#6 - 03/19/2014 09:44 AM - Dominic Cleal
- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#7 - 03/19/2014 09:52 AM - Dominic Cleal
- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/smart-proxy/pull/143

#8 - 03/21/2014 05:52 PM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 597ab3ab9da495f4bef27c1e392693bce506a77b.

Files

puppetlabs-ntp-3.0.3.tar.gz 16.3 KB 03/18/2014 Erik Jacobs

thoraxe-motd-0.1.0.tar.gz 1.91 KB 03/18/2014 Erik Jacobs
https://github.com/theforeman/smart-proxy/pull/143
https://projects.theforeman.org/projects/smart-proxy/repository/7/revisions/597ab3ab9da495f4bef27c1e392693bce506a77b
http://www.tcpdf.org

